/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.calculo_fondo;

import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SQLiteCalculoFondoDAO extends CalculoFondoDAO {
    private static final Logger LOGGER = Logger.getLogger(SQLiteCalculoFondoDAO.class.getName());

    public SQLiteCalculoFondoDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<CalculoFondo> findAll() {
        List<CalculoFondo> calculoFondoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from calculo_fondo";
            PreparedStatement ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            calculoFondoList = this.cajasFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return calculoFondoList;
    }

    @Override
    public List<CalculoFondo> findByCaja(Caja caja) {
        List<CalculoFondo> calculoFondoList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from calculo_fondo where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}  | values: {1}", new Object[]{query, caja.getId()});

            calculoFondoList = this.cajasFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return calculoFondoList;
    }

    @Override
    public CalculoFondo findById(int id) {
        CalculoFondo calculoFondo = null;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from calculo_fondo where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, id});

            calculoFondo = this.cajasFromResultSet(rs).get(0);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return calculoFondo;
    }

    @Override
    public boolean insertCalculoFondo(CalculoFondo calculoFondo) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "insert into calculo_fondo (valor, descripcion, caja_id) values (?, ?, ?)";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, calculoFondo.getValor());
            ps.setString(2, calculoFondo.getDescripcion());
            ps.setInt(3, calculoFondo.getCaja().getId());

            updates = ps.executeUpdate();
            LOGGER.log(Level.FINE, "QUERY {0} | values: [{1}, {2}, {3}] | updates: {4}", new Object[]{query, calculoFondo.getValor(), calculoFondo.getDescripcion(), calculoFondo.getCaja().getId(), updates});

            ps.close();

            ps = conn.prepareStatement("select last_insert_rowid()");
            ResultSet rs = ps.executeQuery();
            LOGGER.log(Level.FINE, "Se ejecuta query: {0}", query);

            rs.next();
            calculoFondo.setId(rs.getInt(1));

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateCalculoFondo(CalculoFondo calculoFondo) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "update calculo_fondo set valor = ?, descripcion = ?, caja_id = ?  where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, calculoFondo.getValor());
            ps.setString(2, calculoFondo.getDescripcion());
            ps.setInt(3, calculoFondo.getCaja().getId());
            ps.setInt(4, calculoFondo.getId());

            updates = ps.executeUpdate();
            LOGGER.log(Level.FINE, "QUERY {0} | values: [{1}, {2}, {3}, {4}] | updates: {5}", new Object[]{query, calculoFondo.getValor(), calculoFondo.getDescripcion(), calculoFondo.getCaja().getId(), updates});


            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteCalculoFondo(CalculoFondo calculoFondo) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "delete from calculo_fondo where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, calculoFondo.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1} | updates: {2}", new Object[]{query, calculoFondo.getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public int getTotalCalculoFondo(Caja caja) {
        int sum = 0;
        try (Connection conn = connectionHolder.getConnection()) {
            String query =  "select sum(valor) from calculo_fondo where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            rs.next();
            sum = rs.getInt(1);

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return sum;
    }
}
